'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _mochaJsdom = require('mocha-jsdom');

var _mochaJsdom2 = _interopRequireDefault(_mochaJsdom);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _reactAddonsTestUtils = require('react-addons-test-utils');

var _authentication = require('../authentication');

var _authentication2 = _interopRequireDefault(_authentication);

var _actions = require('../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AppComponent = (function (_React$Component) {
  _inherits(AppComponent, _React$Component);

  function AppComponent() {
    _classCallCheck(this, AppComponent);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(AppComponent).apply(this, arguments));
  }

  _createClass(AppComponent, [{
    key: 'render',
    value: function render() {
      expect(this.props.isAuthenticated).to.be.equal(true);
      return _react2.default.createElement(
        'div',
        null,
        'App'
      );
    }
  }]);

  return AppComponent;
})(_react2.default.Component);

var App = (0, _reactRedux.connect)(function (state) {
  return {
    isAuthenticated: state.isAuthenticated
  };
})((0, _authentication2.default)(AppComponent));

var renderApp = function renderApp(isAuthenticated) {
  var reducer = (0, _redux.combineReducers)({
    isAuthenticated: isAuthenticated
  });

  var store = (0, _redux.createStore)(reducer);

  return (0, _reactAddonsTestUtils.renderIntoDocument)(_react2.default.createElement(
    _reactRedux.Provider,
    { store: store },
    _react2.default.createElement(App, null)
  ));
};

describe('Authentication', function () {
  (0, _mochaJsdom2.default)();
  describe('with un-authenticated state', function () {
    var isAuthenticated = function isAuthenticated() {
      var state = arguments.length <= 0 || arguments[0] === undefined ? false : arguments[0];
      var action = arguments[1];

      switch (action.type) {
        case _actions.types.GO_TO_LOGIN:
          expect(action.type).to.be.equal(_actions.types.GO_TO_LOGIN);
          return state;
        default:
          return state;
      }
    };

    it('should be ok', function () {
      renderApp(isAuthenticated);
    });
  });

  describe('with authenticated state', function () {
    var isAuthenticated = function isAuthenticated() {
      var state = arguments.length <= 0 || arguments[0] === undefined ? true : arguments[0];
      var action = arguments[1];

      switch (action.type) {
        case _actions.types.GO_TO_LOGIN:
          expect(true).to.be.equal(false);
          return state;
        default:
          return state;
      }
    };

    it('should be ok', function () {
      renderApp(isAuthenticated);
    });
  });
});